/**
 * Temporal Quantified fuzzy DL's
 */

package editor;


import java.awt.Color;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.GroupLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.LayoutStyle;
import javax.swing.SwingConstants;
import javax.swing.border.BevelBorder;

import reasoner.Quantifier;


/**
 * A javax.swing.JDialog for editing Quantifiers
 *
 * @version 1.0 10/12/07
 * @author  marco furlan
 */
public class QuantifierDialog extends JDialog {
        private EditorFrame ef;
      
        /**
         * Creates new QuantifierDialog
         * @param parent the parent
         * @param title the title
         * @param modal the modal
         */
        public QuantifierDialog(JFrame parent, String title, boolean modal) {
            super(parent, title, modal);
            this.ef = (EditorFrame)parent;        
            initComponents();
        }
    
    /** This method is called from within the constructor to
     * initialize the QuantifierDialog.
     */   
    private void initComponents() {
        ButtonGroup buttonGroup1;
        JLabel jLabel1;
        JLabel jLabel10;
        JLabel jLabel13;
        JLabel jLabel2;
        JLabel jLabel3;
        JLabel jLabel5;
        JLabel jLabel6;
        JLabel jLabel7;
        JLabel jLabel8;
        JLabel jLabel9;

        buttonGroup1 = new ButtonGroup();
        jPanel1 = new JPanel();
        jLabel1 = new JLabel();
        jLabel2 = new JLabel();
        okBtn = new JButton();
        jLabel3 = new JLabel();
        jLabel4 = new JLabel();
        jTextField1 = new JTextField();
        jRadioButton1 = new JRadioButton();
        jRadioButton2 = new JRadioButton();
        jLabel5 = new JLabel();
        jTextField2 = new JTextField();
        jLabel6 = new JLabel();
        jLabel7 = new JLabel();
        jTextField3 = new JTextField();
        jTextField4 = new JTextField();
        jLabel8 = new JLabel();
        jTextField5 = new JTextField();
        jLabel9 = new JLabel();
        jTextField6 = new JTextField();
        jLabel10 = new JLabel();
        jLabel11 = new JLabel();
        createBtn = new JButton();
        resetBtn = new JButton();
        exitBtn = new JButton();
        jLabel13 = new JLabel();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jPanel1.setBackground(new java.awt.Color(219, 229, 241));
//        jPanel1.setBorder(javax.swing.BorderFactory.createMatteBorder(2, 2, 2, 2, new java.awt.Color(51, 255, 51)));
        jPanel1.setBorder(javax.swing.BorderFactory.createBevelBorder(BevelBorder.RAISED, new java.awt.Color(51, 255, 51), Color.darkGray));
    	
        jLabel1.setFont(new java.awt.Font("Tahoma", 0, 18));
        jLabel1.setForeground(new java.awt.Color(0, 153, 0));
        jLabel1.setHorizontalAlignment(SwingConstants.CENTER);
        jLabel1.setText("QUANTIFIER EDITOR");
        jLabel1.setHorizontalTextPosition(SwingConstants.CENTER);

        jLabel2.setLabelFor(jTextField1);
        jLabel2.setText("Quantifier Name: ");

        okBtn.setText("OK");
        okBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okBtnActionPerformed(evt);
            }
        });

        jLabel3.setFont(new java.awt.Font("Tahoma", 0, 18));
        jLabel3.setForeground(new java.awt.Color(255, 51, 51));
        jLabel3.setHorizontalAlignment(SwingConstants.LEFT);
        jLabel3.setText("QUANTIFIER AS A Trapezium(a,b,c,d), WHERE y(a) = y(d) = 0.0,  y(b) = y(c) = 1.0 ");

        jLabel4.setText("Quantifier Type:");

        jTextField1.setText("Most");

        buttonGroup1.add(jRadioButton1);
        jRadioButton1.setSelected(true);
        jRadioButton1.setText("Relative");
        jRadioButton1.setBorder(BorderFactory.createLineBorder(new java.awt.Color(102, 102, 255)));
        jRadioButton1.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jRadioButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                radioBtnActionPerformed(evt);
            }
        });

        buttonGroup1.add(jRadioButton2);
        jRadioButton2.setText("Absolute");
        jRadioButton2.setBorder(BorderFactory.createLineBorder(new java.awt.Color(102, 102, 255)));
        jRadioButton2.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jRadioButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                radioBtnActionPerformed(evt);
            }
        });

        jLabel5.setText("maxXVal: ");

        jTextField2.setEditable(false);
        jTextField2.setText("1.0");
        jTextField2.setInputVerifier(new QuantVerifier(this));

        jLabel6.setText("Set Points: ");

        jLabel7.setText("x(a) = ");

        jTextField3.setText("0.4");
        jTextField3.setInputVerifier(new QuantVerifier(this));

        jTextField4.setText("0.6");
        jTextField4.setInputVerifier(new QuantVerifier(this));

        jLabel8.setText("x(b) = ");

        jTextField5.setText("1.0");
        jTextField5.setInputVerifier(new QuantVerifier(this));

        jLabel9.setText("x(c) = ");

        jTextField6.setText("1.0");
        jTextField6.setInputVerifier(new QuantVerifier(this));

        jLabel10.setText("x(d) = ");

        jLabel11.setText("Most                               ");

        createBtn.setText("Create Quantifier");
        createBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                createButtonActionPerformed(evt);
            }
        });

        resetBtn.setText("Reset");
        resetBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                resetBtnActionPerformed(evt);
            }
        });

        exitBtn.setText("Exit");
        exitBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitBtnActionPerformed(evt);
            }
        });

        jLabel13.setFont(new java.awt.Font("Tahoma", 0, 18));
        jLabel13.setForeground(new java.awt.Color(255, 51, 51));
        jLabel13.setHorizontalAlignment(SwingConstants.LEFT);
        jLabel13.setText("AND 0.0 <= x(a) <= x(b) <= x(c) <= x(d) <= maxXVal ");

        GroupLayout jPanel1Layout = new GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(238, 238, 238)
                        .addComponent(jLabel1))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(39, 39, 39)
                        .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(jLabel4)
                                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                                    .addComponent(jRadioButton2)
                                    .addComponent(jRadioButton1, GroupLayout.PREFERRED_SIZE, 151, GroupLayout.PREFERRED_SIZE))
                                .addGap(68, 68, 68)
                                .addComponent(jLabel5)
                                .addGap(37, 37, 37)
                                .addComponent(jTextField2, GroupLayout.PREFERRED_SIZE, 34, GroupLayout.PREFERRED_SIZE))
                            .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.TRAILING)
                                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel2)
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addComponent(jLabel6)
                                        .addGap(32, 32, 32)
                                        .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                                            .addComponent(jLabel11, GroupLayout.PREFERRED_SIZE, 155, GroupLayout.PREFERRED_SIZE)
                                            .addGroup(jPanel1Layout.createSequentialGroup()
                                                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.TRAILING)
                                                    .addComponent(jTextField1, GroupLayout.PREFERRED_SIZE, 135, GroupLayout.PREFERRED_SIZE)
                                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                                        .addComponent(jLabel7)
                                                        .addGap(13, 13, 13)
                                                        .addComponent(jTextField3, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                                                        .addGap(18, 18, 18)
                                                        .addComponent(jLabel8)))
                                                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(jTextField4, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                                                .addGap(16, 16, 16)
                                                .addComponent(jLabel9)
                                                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(jTextField5, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                                                .addGap(29, 29, 29)
                                                .addComponent(jLabel10)
                                                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(jTextField6, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))))
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addComponent(okBtn)
                                        .addGap(64, 64, 64)
                                        .addComponent(createBtn)
                                        .addGap(320, 320, 320)
                                        .addComponent(resetBtn)
                                        .addGap(85, 85, 85)
                                        .addComponent(exitBtn)))
                                .addComponent(jLabel13)
                                .addComponent(jLabel3)))))
                .addContainerGap(86, Short.MAX_VALUE))
        );

        jPanel1Layout.linkSize(0, new java.awt.Component[] {jLabel10, jLabel7, jLabel8, jLabel9, jTextField3, jTextField4, jTextField5, jTextField6} );

        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(29, 29, 29)
                .addComponent(jLabel1, GroupLayout.PREFERRED_SIZE, 26, GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel3, GroupLayout.PREFERRED_SIZE, 26, GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel13, GroupLayout.PREFERRED_SIZE, 26, GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addGroup(GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel5)
                            .addComponent(jTextField2, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                        .addGap(64, 64, 64))
                    .addGroup(GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel4)
                            .addComponent(jRadioButton1))
                        .addGap(19, 19, 19)
                        .addComponent(jRadioButton2)
                        .addGap(26, 26, 26)))
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(jTextField1, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                .addGap(47, 47, 47)
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(jLabel7)
                    .addComponent(jTextField3, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel9)
                    .addComponent(jTextField5, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel10)
                    .addComponent(jTextField6, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel8)
                    .addComponent(jTextField4, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(27, 27, 27)
                        .addComponent(jLabel11)
                        .addGap(47, 47, 47)
                        .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                            .addComponent(okBtn)
                            .addComponent(createBtn)))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(81, 81, 81)
                        .addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                            .addComponent(exitBtn)
                            .addComponent(resetBtn))))
                .addGap(79, 79, 79))
        );
        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        pack();
    }

    /**
     * Invoked when an action is performed on exitBtn
     * @param evt the event
     */
    private void exitBtnActionPerformed(java.awt.event.ActionEvent evt) {
      closeDialog();
    }

    /**
     * Invoked when an action is performed on resetBtn: resets the textFields
     * to default values
     * @param evt the event
     */
    private void resetBtnActionPerformed(java.awt.event.ActionEvent evt) {
        jTextField3.setText("0.0"); 
        jTextField4.setText("0.0"); 
        jTextField5.setText("0.0");
        jTextField6.setText("0.0");
        jTextField2.setText("1.0");                
        jRadioButton1.setSelected(true);
        jRadioButton2.setSelected(false);
    }

    /**
     * Invoked when an action is performed on okBtn
     * @param evt the event
     */
    private void okBtnActionPerformed(java.awt.event.ActionEvent evt) {
         closeDialog();
         }

    /**
     * closes this QuantifierDialog   
     */
    private void closeDialog(){
        setVisible(false);
        ef.showKb();
        dispose();
    }
    /**
     * Invoked when an action is performed on createBtn: creates new Quantifier
     * @param evt the event
     */
    private void createButtonActionPerformed(java.awt.event.ActionEvent evt) {
       double a=Double.valueOf(jTextField3.getText()), 
               b=Double.valueOf(jTextField4.getText()), 
               c=Double.valueOf(jTextField5.getText()),
                d=Double.valueOf(jTextField6.getText()),
                m=Double.valueOf(jTextField2.getText());
        if(a<=b && b<=c && c<=d && d<= m){
           String name = jTextField1.getText();
            Quantifier q = new Quantifier(name,a,b,c,d,m,ef.getKb());            
            q.setRelative(jRadioButton1.isSelected());
            jLabel11.setText(q.getMeaning());
            ef.getQuantCB().addItem(q.getName());
            ef.getQuantCB().setSelectedItem(q.getName());
        }else{
           JOptionPane.showMessageDialog(null ," x(a) <= x(b) <= x(c) <= x(d) <= maxVal, please! ","WARNING",JOptionPane.ERROR_MESSAGE);
        }
    }
  

    /**
     * Invoked when an action is performed on radioBtn
     * @param evt the event
     */
    private void radioBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton1ActionPerformed
        if (jRadioButton1.isSelected()){
            jRadioButton2.setSelected(false);
            jTextField2.setText("1.0");
            jTextField2.setEditable(false);
        }
        if(jRadioButton2.isSelected()){
            jRadioButton1.setSelected(false);
            jTextField2.setEditable(true);
        }
    }
    
    /** 
     * Closes this QuantifierDialog
     */
    private void closeDialog(java.awt.event.WindowEvent evt) {
        setVisible(false);
        ef.showKb();
        dispose();
    }
    
    /**
     * the main method
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                String title = "Quantifier Editor";
                new QuantifierDialog(new  EditorFrame(), title, true).setVisible(true);
                
            }
        });
    }
    
    
    // Variables declaration 
    protected JButton okBtn;
    protected JButton createBtn;
    protected JButton resetBtn;
    protected JButton exitBtn;
    protected JLabel jLabel11;
    private JLabel jLabel4;
    private JPanel jPanel1;
    private JRadioButton jRadioButton1;
    private JRadioButton jRadioButton2;
    protected JTextField jTextField1;
    protected JTextField jTextField2;
    protected JTextField jTextField3;
    protected JTextField jTextField4;
    protected JTextField jTextField5;
    protected JTextField jTextField6;
   
    
}
