/**
 * 
 */
package monitorDb;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import java.text.NumberFormat;
//import java.util.Iterator;
//import java.util.Set;
//import java.util.Vector;

//import reasoner.Concept;
import reasoner.KnowledgeBase;
//import reasoner.RoleQuery;
//import reasoner.ULineEvent;

//import java.beans.PropertyChangeEvent;
//import java.beans.PropertyChangeListener;

//import javax.swing.DebugGraphics;



/**
 * @author marco furlan
 *
 */
public class GraphPanel extends javax.swing.JPanel
//implements Runnable
{
//	Graphics g;
	MonitorJFrame mf;
	KnowledgeBase kb;
//	GraphicULineSet cities;
//	Vector val;
	double maxval = 1.0;
	double minval = 0.0;
	int nw, nh, nhor, nvert, ux, uy, lx,ly;	
	private static NumberFormat formatter;
	private boolean show=false;
//	Thread myThread;
	Image img;
	/**
	 * @return the show
	 */
	public boolean isShow() {
		return show;
	}

	/**
	 * @param show the show to set
	 */
	public void setShow(boolean show) {
		this.show = show;
	}

	/**
	 * 
	 */
	public GraphPanel(MonitorJFrame mf) {
//		System.out.println("costruttore gp inizio");		

		this.mf = mf; 				
		this.setOpaque(true);	
		setShow(false);
        formatter = NumberFormat.getNumberInstance();
		formatter.setMaximumFractionDigits(1);	
//		setDebugGraphicsOptions(DebugGraphics.LOG_OPTION );
//		this.g=this.getGraphics();
//		System.out.println("g: "+ g.toString());
//		System.out.println("costruttore gp fine");
	}

//	public void  initComponents(){		
////		setBackground(Color.white);
////		setBorder(javax.swing.BorderFactory.createMatteBorder(1,1,1,1, Color.gray)); 
//	}

	public synchronized void update(Graphics g) {
		paint(g);
	}

	public  void paint(Graphics g) {		
		nw = this.getWidth();	
		nh = this.getHeight();			

		drawGrid(g);
		if (isShow())				
			this.getMf().getMonitor().getGraphicULineSet().draw(g, this);
	}

	public void drawPoint(Graphics g, int x, int y, boolean firstC){
		if (firstC)
			g.fillOval(x-4, y-4, 9, 9);
		else
			g.fillRect(x-4, y-4, 9, 9);
	}

//	public void drawPoint(Graphics g, int x, int y, String s, boolean firstC, boolean end){
////		int n=(end?30:0);
////		g.setColor(Color.red);
//		if (firstC)
//			g.fillOval(x-4, y-4, 9, 9);
//		else
//			g.fillRect(x-4, y-4, 9, 9);
////		g.drawString(s,x-n,y);
//	}
	
	public void drawLine (Graphics g, int x1, int y1,int x2, int y2){
//		g.setColor(Color.blue);
		g.drawLine(x1, y1, x2, y2);	
	}
	public void drawChars (Graphics g,char[] c, int offset, int length, int x, int y){
		g.drawChars(c,offset, length, x+5 , y-1);
	}
	 public void drawGrid(Graphics g){
		 
//		 setBackground(Color.white);
		 g.setColor(Color.white);
		 g.fillRect(0, 0, nw, nh);
		 g.setColor(Color.gray);
		 g.drawRect(0, 0, nw-1, nh-1);
		 nhor = 21;
		 nvert = 11;
		 ux = nw/(nhor);
		 uy = nh/(nvert);
		 ly = uy*(nvert-1);
		 lx = ux*(nhor-1);
		 for(int i=1;i<=nhor;i++){
			 g.drawLine(ux*i, uy, ux*i, uy*nvert);
		 }
		 for(int i=1;i<=nvert;i++){
			 double y = uy*i;
			 double v = getYval(y);
			 g.setColor(Color.blue);
			 g.drawString(""+formatter.format(v),4,(int)y);
			 g.setColor(Color.gray);
			 g.drawLine(ux,(int)y, ux*nhor,(int)y);
		 }
//		 System.out.println("drawGrid: fine");
	 }


	 public int getX (double i, int size){			 
		 return (int)( ux +i*lx/(size-1));
	 }

	 public int getY (double v){
		 return (int)(uy+ly*(maxval-v)/(maxval-minval));
	 }

	 public double getYval(double y){
		 return maxval - (maxval-minval)*(y-uy)/ly;
	 }

	/**
	 * @return the mf
	 */
	public MonitorJFrame getMf() {
		return mf;
	}

	/**
	 * @param mf the mf to set
	 */
	public void setMf(MonitorJFrame mf) {
		this.mf = mf;
	}

	/**
	 * @return the kb
	 */
	public KnowledgeBase getKb() {
		return kb;
	}

	/**
	 * @param kb the kb to set
	 */
	public void setKb(KnowledgeBase kb) {
		this.kb = kb;
	}
//	 public void start() {
//		 System.out.println("start");
//	        myThread = new Thread(this);
//	        myThread.start();
//	    }
//
//	    public void stop() { 
//	    	 System.out.println("stop");
//	    	myThread = null;
//	    }
//	public void run() {
//		 System.out.println("run");
//		Thread me = Thread.currentThread();
//		while (me==myThread){
//			System.out.println("repaint:");
//		repaint();
//		System.out.println("after repaint");
//		try {
//			 System.out.println("sleep:");
//            Thread.sleep(500);
//            System.out.println("after sleep");
//        } catch (InterruptedException e) {
//            break;
//        }
//		}
//		
//	}

//	/**
//	 * @return the cities
//	 */
//	public GraphicULineSet getGraphicULineSet() {
//		return cities;
//	}
//
//	/**
//	 * @param cities the cities to set
//	 */
//	public void setGraphicULineSet(GraphicULineSet cities) {
//		this.cities = cities;
//	}
}
