package monitorDb;

import java.awt.Color;
import java.awt.Graphics;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;
import java.util.Vector;

import reasoner.Concept;
import reasoner.Individual;
import reasoner.KnowledgeBase;
import reasoner.Query;
import reasoner.ULineEvent;
import reasoner.RoleQuery;
import reasoner.OpQuery;
import util.Point;

/**
 * @author marco furlan
 *
 */
public class GraphicULineSet {
	private Vector lines, 
//	pColors,
	lColors;
	private boolean created;
	private int lc=0;
//	private int pc=0;
	private HashMap lCs;
	private boolean first;
	
	public GraphicULineSet(){
		created = false;
		first = true;
		lines = new Vector<GraphicULine>();			
//		pColors = new Vector<Color>();
		lColors = new Vector<Color>();
		lCs = new HashMap<ULineEvent, Color>();
//		pColors.add(Color.red);pColors.add(Color.green);  pColors.add(Color.yellow);
//		pColors.add(Color.blue); pColors.add(Color.cyan);pColors.add(Color.magenta);
//		pColors.add(Color.darkGray); pColors.add(Color.orange);pColors.add(Color.pink);pColors.add(Color.lightGray);
		
		lColors.add(Color.blue);lColors.add(Color.green); lColors.add(Color.magenta);
		lColors.add(Color.orange ); lColors.add(Color.red);lColors.add(Color.cyan);
		lColors.add(Color.blue); lColors.add(Color.darkGray);lColors.add(Color.pink);lColors.add(Color.lightGray);
		
	}
	
	public void create (Query qry, KnowledgeBase kb){
		if (qry.getClass().getName().equals("reasoner.RoleQuery")){
			System.out.println("is RoleQuery: " + qry.toString());
			this.create(((RoleQuery)qry).getC(), kb);
		}
		else if (qry.getClass().getName().equals("reasoner.OpQuery")){
			System.out.println("is OpQuery: " + qry.toString());
			Concept c1,c2;
			c1 = ((OpQuery)qry).getC1();
			this.create(c1, kb);
			c2 = (( OpQuery)qry).getC2();
			if (null!=c2 && !c2.equals(c1))
				this.create(c2, kb);
		}
	}
	public synchronized void create(Concept c, KnowledgeBase kb){
		Set keys, ckeys;
		Iterator it, cit;
		Individual ind;
		GraphicULine cl;
		ULineEvent ul;
		Concept inter;
		Color ulColor;
		double x, val;
		int size;
		keys = kb.getULineEvents().keySet();		
		it = keys.iterator();
		while(it.hasNext()){			
			ul = (ULineEvent) kb.getULineEvents().get(it.next());
			if (lCs.containsKey(ul))
				ulColor=(Color)(lCs.get(ul));
			else {
				ulColor = (Color)lColors.get(lc++);
				lCs.put(ul, ulColor);
			}
//			cl = new GraphicULine(ul.getName(),(Color)pColors.get(pc), ulColor);
//			cl = new GraphicULine(ul.getName(),first, ulColor);
			cl = new GraphicULine(ul.getName(),c.getName(),first, ulColor);
			inter = c.intersection(ul); 
			
			ckeys = inter.getEvKeys();
			size = ckeys.size();
			cit = ckeys.iterator();
			x = 0.0;			
			while (cit.hasNext()){				
				ind = (Individual)cit.next();					
				val =  (Double)inter.get(ind);
				x = ind.getTime();
				cl.addPoint(new Point(x,val));			
			}	
			this.addLine(cl);
		}	
		first = !first;
//		pc++;
		setCreated(true);
//		System.out.println("GraphicULineSet created");
	}
	
	/**
	 * to be called after creation, for a more concept
	 * @param v the vector of GraphicULine to be added
	 */
	public void addAll(Vector<GraphicULine> v){
		this.getLines().addAll(v);
	}
	
	public void draw(Graphics g, GraphPanel gp){
//		System.out.println("GraphicULineSet.draw: ");
		if(isCreated())	{	
//			System.out.println("GraphicULineSet are created: now we draw: ");
//			System.out.println("g: "+g.toString());
		GraphicULine cl;
		Iterator it = getLines().iterator();
		while (it.hasNext()){
			cl = (GraphicULine)it.next();
//			System.out.println("City name: " + cl.getName());
			cl.draw(g, gp);
		}
		gp.getMf().getLegenda().repaint();
		}
//		System.out.println("GraphicULineSet drawn");
	}
	
	
	public void addLine(GraphicULine cl){
		this.getLines().add(cl);
	}
	/**
	 * @return the lines
	 */
	public Vector getLines() {
		return lines;
	}
	/**
	 * @param lines the lines to set
	 */
	public void setLines(Vector lines) {
		this.lines = lines;
	}
	/**
	 * @return the created
	 */
	public boolean isCreated() {
		return created;
	}
	/**
	 * @param created the created to set
	 */
	public void setCreated(boolean created) {
		this.created = created;
	}
}
