/**
 * 
 */
package monitorPresentation;

import java.awt.Color;
import java.awt.GraphicsConfiguration;
import java.awt.HeadlessException;
import java.awt.event.ActionEvent;
import java.io.FileNotFoundException;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.border.BevelBorder;
import javax.xml.bind.JAXBException;
//import editor.*;

import editor.EditorFrame;



/**
 * @author marco furlan
 *
 */
public class MonitorPresentation extends JFrame {
	 private JMenuBar menuBar;
	    private JMenu monitorMenu, editorMenu;
	    private JMenuItem prayMenuItem;	    
	    private JMenuItem locMenuItem;
	    private JMenuItem pressMenuItem;
	    private JMenuItem editorMenuItem;
	    private JButton goBtn;
	    private JButton exitBtn;
	    private JLabel monitorLbl, monitorLbl1;
	    // End of variables declaration                   
//	    Monitor m;
	    private static String title = "Monitor Chooser";

	/**
	 * @throws HeadlessException
	 */
	public MonitorPresentation() throws HeadlessException {
		super(title);
		this.setLocation(5, 8);
		initComponents();
	}

	/**
	 * @param gc
	 */
	public MonitorPresentation(GraphicsConfiguration gc) {
		super(gc);
		// TODO Auto-generated constructor stub
	}

	/**
	 * @param title
	 * @throws HeadlessException
	 */
	public MonitorPresentation(String title) throws HeadlessException {
		super(title);
		// TODO Auto-generated constructor stub
	}

	/**
	 * @param title
	 * @param gc
	 */
	public MonitorPresentation(String title, GraphicsConfiguration gc) {
		super(title, gc);
		// TODO Auto-generated constructor stub
	}
	
	 private void initComponents() {
	        goBtn = new JButton();
	        exitBtn = new JButton();
	        monitorLbl = new JLabel();
	        monitorLbl1 = new JLabel();
	        menuBar = new JMenuBar();
	        monitorMenu = new JMenu();
	        editorMenu = new JMenu();
	        prayMenuItem = new JMenuItem();
	        locMenuItem = new JMenuItem();	       
	        pressMenuItem = new JMenuItem();
	        editorMenuItem = new JMenuItem();

	        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
	        this.getContentPane().setBackground(new Color(219,229,241));
//	        this.getRootPane().setBorder(javax.swing.BorderFactory.createMatteBorder(2, 2, 2, 2, new java.awt.Color(51, 255, 51)));
	        this.getRootPane().setBorder(javax.swing.BorderFactory.createBevelBorder(BevelBorder.RAISED, new java.awt.Color(51, 255, 51), Color.darkGray));
	        			    
	        goBtn.setText("Go");
	        goBtn.addActionListener(new java.awt.event.ActionListener() {
	            public void actionPerformed(java.awt.event.ActionEvent evt) {
	                goActionPerformed(evt);
	            }				
	        });
	        goBtn.setEnabled(false);

	        exitBtn.setText("Exit");
	        exitBtn.addActionListener(new java.awt.event.ActionListener() {
	            public void actionPerformed(java.awt.event.ActionEvent evt) {
	            	System.exit(0);
	            }				
	        });

	        monitorLbl1.setText("Monitoring: ");

	        monitorMenu.setText("monitor");
	        monitorMenu.setToolTipText("choose monitor ...");
	        editorMenu.setText("editor");
	        editorMenu.setToolTipText("editor...");
	        prayMenuItem.setText("pray - predator");
	        prayMenuItem.setToolTipText("pray - predator");
	        prayMenuItem.setDisplayedMnemonicIndex(0);

	        prayMenuItem.addActionListener(new java.awt.event.ActionListener() {
	            public void actionPerformed(java.awt.event.ActionEvent evt) {
	               itemActionPerformed (evt);
	            }
	        });

	        monitorMenu.add(prayMenuItem);

	        locMenuItem.setText("locality temperatures");
	        locMenuItem.setToolTipText("locality temperatures");
	        locMenuItem.setDisplayedMnemonicIndex(9);
	        locMenuItem.addActionListener(new java.awt.event.ActionListener() {
	            public void actionPerformed(java.awt.event.ActionEvent evt) {
	                itemActionPerformed(evt);
	            }
	        });
	        monitorMenu.add(locMenuItem);

	        pressMenuItem.setText("blood pressure");
	        pressMenuItem.setToolTipText("blood pressure");
	        pressMenuItem.setDisplayedMnemonicIndex(0);
	        pressMenuItem.addActionListener(new java.awt.event.ActionListener() {
	            public void actionPerformed(java.awt.event.ActionEvent evt) {
	                itemActionPerformed(evt);
	            }
	        });
	        monitorMenu.add(pressMenuItem);
	        editorMenuItem.setText("query editor");
	        editorMenuItem.setToolTipText("query and kb editor");
	        editorMenuItem.setDisplayedMnemonicIndex(0);
	        editorMenuItem.addActionListener(new java.awt.event.ActionListener() {
	            public void actionPerformed(java.awt.event.ActionEvent evt) {
	                editActionPerformed(evt);
	            }				
	        });
	        editorMenu.add(editorMenuItem);
	        menuBar.add(editorMenu);
	        menuBar.add(monitorMenu);

	        setJMenuBar(menuBar);

	        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
	        getContentPane().setLayout(layout);
	        layout.setHorizontalGroup(
	            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
	            .addGroup(layout.createSequentialGroup()
	                .addGap(98, 98, 98)
	                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
	                    .addGroup(layout.createSequentialGroup()
	                    	.addComponent(monitorLbl1)
	                    	.addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
	                        .addComponent(monitorLbl)
	                        .addGap(10,213,Short.MAX_VALUE))
	                    .addGroup(layout.createSequentialGroup()
	                        .addComponent(goBtn)
	                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 96, Short.MAX_VALUE)
	                        .addComponent(exitBtn)
	                        .addGap(88, 88, 88))))                        
	                        
	        );
	        layout.setVerticalGroup(
	            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
	            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
	                .addGap(40, 40, 40)
	                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
	                		.addComponent(monitorLbl1)
	                		.addComponent(monitorLbl))
	                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 102, Short.MAX_VALUE)
	                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
	                    .addComponent(goBtn)
	                    .addComponent(exitBtn))
	                .addGap(91, 91, 91))                
	               
	        );
	        pack();
	    }
	    private void itemActionPerformed(java.awt.event.ActionEvent evt) {                                  
	    	String s = ((JMenuItem)evt.getSource()).getText();
	    	monitorLbl.setText(s);
	    	goBtn.setEnabled(true);
	    } 
	    private void editActionPerformed(ActionEvent evt) {
			EditorFrame.main(null);
			
		}
	    private void goActionPerformed(ActionEvent evt) {
	    	String s = monitorLbl.getText();
	    	if (s.equals("pray - predator")){	    		
	    		try {
	    			monitor.Monitor.main(null);
	    		} catch (FileNotFoundException e) {				
	    			e.printStackTrace();
	    		} catch (JAXBException e) {
	    			e.printStackTrace();
	    		}
	    		prayPredator.XmlPrayPredator.main(null);
	    	} else if (s.equals("locality temperatures")){
	    		String[] args = {"LocalityTemperature"};
	    		monitorDb.Monitor.main(args);
	    	}else if (s.equals("blood pressure")){
	    		String[] args = {"BloodPressure"};
	    		monitorDb.Monitor.main(args);
	    	}
//	        java.awt.EventQueue.invokeLater(new Runnable() {
//	            public void run() {//	                     
//	                m = new Monitor();	              
//	                
//	        }});
			
		}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		  java.awt.EventQueue.invokeLater(new Runnable() {
	            public void run() {
	                new MonitorPresentation().setVisible(true);
	            }
	        });

	}

}
