/**
 * Temporal Quantified fuzzy DL's
 */
package reasoner;

/**
 * This  class represents the Static Individuals.
 * Every StaticInd has time set to the NOW contant.
 * @author marco furlan
 *
 */
public class StaticInd extends Individual {

	/**
	 * Constructs a new StaticInd, by name and KnowledgeBase.
	 * It's time is set to the constant NOW.
	 * @param name the name
	 * @param kb the KnowledgeBase
	 */
	public StaticInd(String name, KnowledgeBase kb) {		
		super(name, kb);
		setTime(getNOW());
//		getKb().addIndividual(this);
	}

	/**
	 * Constructs a new StaticInd, by name, time and KnowledgeBase.
	 * It's time has to be equals to the constant NOW. This constructor is
	 * the same as the constructor  by name and KnowledgeBase.
	 * @param name the name
	 * @param time
	 * @param kb the KnowledgeBase
	 */
	public StaticInd(String name, double time,	KnowledgeBase kb) {
		this(name, kb);	
	}
	
	/**
	 * Evaluates the membership value for this StaticInd in the given
	 * Concept
	 * @param c the Concept
	 * @see reasoner.Individual#degree(reasoner.Concept)
	 */
	public double degree(Concept c){
		System.out.print(c.getName()+"("+this.getName()+"): ");
		if (c.getStaticMap().containsKey(this)){
			System.out.println(c.getStaticMap().get(this));
			return c.getStaticMap().get(this);
		}
		else{ 
			System.out.println(0.0);
			return 0.0;
		}
	}

}
