/**
 * Temporal Quantified fuzzy DL's
 */
package reasoner;

/**
 * This class represents Universal Line Individuals as subclass of DynamicInd
 * @author marco furlan
 */
public class ULineInd extends DynamicInd {

	/**
	 * Constructs a new ULineInd by name, ULineEvent and Knowledge Base.
	 * It's time is set to the SELF constant
	 * @param name the name
	 * @param line the ULineEvent
	 * @param kb the Knowledge Base
	 */
	public ULineInd(String name, ULineEvent line, KnowledgeBase kb)  {		
		super(name,line, 0.0 ,kb);	
		setTime(getSELF());
//		getKb().addIndividual(this);
	}

	/**
	 * Constructs a new ULineInd by name, ULineEvent, time and Knowledge Base
	 * @param name the name
	 * @param line the ULineEvent
	 * @param time the time
	 * @param kb the Knowledge Base
	 */
	public ULineInd(String name, ULineEvent line, double time,
			KnowledgeBase kb) {
		super(name,line, time, kb);		
//		setULineEvent(line);		
//		line.add(time, this);		
	}
	
	/**
	 * Evaluates the membership value for this Individual in the given
	 * Concept
	 * @param c the Concept	
	 * @see reasoner.Individual#degree(reasoner.Concept)
	 */
	public double degree(Concept c){
		System.out.print(c.getName()+"("+this.getName()+"): ");
//		if(c.containsUlKey(this))
		if(c.containsKey(this))
//			return this.getULine().max(c);	
			return c.getULineMap().get(this);
				else{ 
			System.out.println(0.0);
			return 0.0;
		}
	}

}
